# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify Alma, CentOS, CentOS Stream and Rocky Linux as rhel
%if "%{__distinit}" == "a" || "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "cs" || "%{__distinit}" == "rl"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

Name:		perl-Object-HashBase
Version:	0.013
Release:	1.%{__distinit}%{__distvers}
Summary:	Build hash-based classes
License:	GPL-1.0-or-later OR Artistic-1.0-Perl
URL:		https://metacpan.org/release/Object-HashBase
Source0:	https://cpan.metacpan.org/modules/by-module/Object/Object-HashBase-%{version}.tar.gz
Patch0:		Object-HashBase-0.008-Normalize-shebang.patch
BuildArch:	noarch
# Build
BuildRequires:	coreutils
BuildRequires:	findutils
BuildRequires:	make
BuildRequires:	perl-generators
BuildRequires:	perl-interpreter
BuildRequires:	perl(ExtUtils::MakeMaker)
# Runtime
BuildRequires:	perl(base)
BuildRequires:	perl(Carp)
BuildRequires:	perl(strict)
BuildRequires:	perl(Test::More) >= 0.98
BuildRequires:	perl(vars)
BuildRequires:	perl(warnings)
# Test Suite
BuildRequires:	perl(File::Temp)
# Dependencies
%if 0%{?fedora} < 38 && 0%{?rhel} < 10
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
%endif
%if 0%{?fedora} > 20 || 0%{?rhel} > 7
Suggests:	perl(Class::XSAccessor) >= 1.19
%else
Requires:	perl(Class::XSAccessor) >= 1.19
%endif

# Remove private modules
%global __requires_exclude ^perl\\(Object::HashBase::Test::HBase.*

%description
This package is used to generate classes based on hash references. Using this
class will give you a new() method, as well as generating accessors you
request.  Generated accessors will be getters, set_ACCESSOR setters will also
be generated for you. You also get constants for each accessor (all caps)
which return the key into the hash for that accessor. Single inheritance is
also supported.

%package tools
Summary:	Generate inlined Object::HashBase Perl module
Requires:	%{name} = %{version}-%{release}
%if 0%{?fedora} < 38 && 0%{?rhel} < 10
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
%endif
Requires:	perl(Test::More) >= 0.98

%description tools
hashbase_inc.pl script generates a Perl module that contains an
Object::HashBase module mangled into a name space of your choice.
It can also generate the tests for it.

%prep
%setup -q -n Object-HashBase-%{version}

# Correct shellbangs
%patch -P 0 -p1

%build
perl Makefile.PL INSTALLDIRS=vendor
make %{?_smp_mflags}

%install
make pure_install DESTDIR=%{buildroot}
find %{buildroot} -type f -name .packlist -delete
%{_fixperms} -c %{buildroot}

%check
make test

%files
%license LICENSE
%doc Changes README
%dir %{perl_vendorlib}/Object/
%{perl_vendorlib}/Object/HashBase.pm
%{_mandir}/man3/Object::HashBase.3*

%files tools
%{_bindir}/hashbase_inc.pl
%{perl_vendorlib}/Object/HashBase/

%changelog
* Fri Mar 22 2024 Paul Howarth <paul@city-fan.org> - 0.013-1
- Update to 0.013
  - Add support for Class::XSAccessor when it is installed
  - Documentation fixes

* Thu Jan 25 2024 Paul Howarth <paul@city-fan.org> - 0.010-3
- Re-rebuilt for https://fedoraproject.org/wiki/Fedora_40_Mass_Rebuild
  (see https://pagure.io/releng/issue/11888)

* Mon Jan 22 2024 Paul Howarth <paul@city-fan.org> - 0.010-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_40_Mass_Rebuild

* Mon Oct 23 2023 Paul Howarth <paul@city-fan.org> - 0.010-1
- Update to 0.010
  - Documentation fixes (GH#3)

* Fri Jul 21 2023 Paul Howarth <paul@city-fan.org> - 0.009-13
- Rebuilt for https://fedoraproject.org/wiki/Fedora_39_Mass_Rebuild

* Tue Jan 24 2023 Paul Howarth <paul@city-fan.org> - 0.009-12
- Rebuilt for https://fedoraproject.org/wiki/Fedora_38_Mass_Rebuild

* Mon Dec 12 2022 Paul Howarth <paul@city-fan.org> - 0.009-11
- Use SPDX-format license tag

* Mon Jul 25 2022 Paul Howarth <paul@city-fan.org> - 0.009-10
- Rebuilt for https://fedoraproject.org/wiki/Fedora_37_Mass_Rebuild

* Tue Jun  7 2022 Paul Howarth <paul@city-fan.org> - 0.009-9
- Perl 5.36 rebuild

* Mon Jan 24 2022 Paul Howarth <paul@city-fan.org> - 0.009-8
- Rebuilt for https://fedoraproject.org/wiki/Fedora_36_Mass_Rebuild

* Mon Jul 26 2021 Paul Howarth <paul@city-fan.org> - 0.009-7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_35_Mass_Rebuild
- Fix dist tags for Alma and Rocky Linux

* Tue May 25 2021 Paul Howarth <paul@city-fan.org> - 0.009-6
- Perl 5.34 rebuild

* Tue Feb  2 2021 Paul Howarth <paul@city-fan.org> - 0.009-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_34_Mass_Rebuild

* Sun Aug  2 2020 Paul Howarth <paul@city-fan.org> - 0.009-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_33_Mass_Rebuild

* Mon Jun 29 2020 Paul Howarth <paul@city-fan.org> - 0.009-3
- Perl 5.32 rebuild

* Thu Feb  6 2020 Paul Howarth <paul@city-fan.org> - 0.009-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_32_Mass_Rebuild

* Sun Jan 19 2020 Paul Howarth <paul@city-fan.org> - 0.009-1
- Update to 0.009
  - Add workaround for test issue with Perl ≤ 5.6.2

* Fri Nov 22 2019 Paul Howarth <paul@city-fan.org> - 0.008-2
- Import from Fedora

* Tue Nov 19 2019 Petr Pisar <ppisar@redhat.com> - 0.008-1
- Specfile autogenerated by cpanspec 1.78
